Index: cprs/trunk/CPRS-Chart/Orders/fODMeds.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 829)
@@ -8,5 +8,5 @@
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   fODBase, StdCtrls, ComCtrls, ExtCtrls, ORCtrls, Grids, Buttons, uConst, ORDtTm,
-  Menus, XUDIGSIGSC_TLB;
+  Menus, XUDIGSIGSC_TLB, VA508AccessibilityManager, VAUtils, Contnrs;
 
 const
@@ -26,6 +26,4 @@
     cboXRoute: TORComboBox;
     pnlXDuration: TPanel;
-    pnlXSequence: TKeyClickPanel;
-    btnXSequence: TSpeedButton;
     timCheckChanges: TTimer;
     popDuration: TPopupMenu;
@@ -34,7 +32,4 @@
     hours1: TMenuItem;
     minutes1: TMenuItem;
-    popXSequence: TPopupMenu;
-    and1: TMenuItem;
-    then1: TMenuItem;
     months1: TMenuItem;
     weeks1: TMenuItem;
@@ -78,6 +73,4 @@
     radPickClinic: TRadioButton;
     cboPriority: TORComboBox;
-    chkSC: TCheckBox;
-    lblAdminTime: TStaticText;
     stcPI: TStaticText;
     chkPtInstruct: TCheckBox;
@@ -86,5 +79,8 @@
     memDrugMsg: TMemo;
     txtNSS: TLabel;
-    SpeedButton1: TSpeedButton;
+    pnlXAdminTime: TPanel;
+    cboXSequence: TORComboBox;
+    lblAdminSch: TMemo;
+    lblAdminTime: TVA508StaticText;
     procedure FormCreate(Sender: TObject);
     procedure btnSelectClick(Sender: TObject);
@@ -138,13 +134,8 @@
     procedure cboXRouteChange(Sender: TObject);
     procedure cboXScheduleChange(Sender: TObject);
-    procedure pnlXSequenceExit(Sender: TObject);
-    procedure btnXSequenceClick(Sender: TObject);
     procedure grdDosesExit(Sender: TObject);
     procedure ListViewEnter(Sender: TObject);
     procedure timCheckChangesTimer(Sender: TObject);
     procedure popDurationClick(Sender: TObject);
-    procedure popXSequenceClick(Sender: TObject);
-    procedure chkSCEnter(Sender: TObject);
-    procedure chkSCClick(Sender: TObject);
     procedure cmdAcceptClick(Sender: TObject);
     procedure btnXInsertClick(Sender: TObject);
@@ -167,5 +158,4 @@
       Shift: TShiftState);
     procedure cboXRouteEnter(Sender: TObject);
-    procedure pnlXSequenceEnter(Sender: TObject);
     procedure pnlMessageEnter(Sender: TObject);
     procedure pnlMessageExit(Sender: TObject);
@@ -174,7 +164,4 @@
     procedure memPIClick(Sender: TObject);
     procedure FormResize(Sender: TObject);
-    procedure spnQuantityChangingEx(Sender: TObject;
-      var AllowChange: Boolean; NewValue: Smallint;
-      Direction: TUpDownDirection);
     procedure memPIKeyDown(Sender: TObject; var Key: Word;
       Shift: TShiftState);
@@ -196,12 +183,17 @@
     procedure WMClose(var Msg : TWMClose); message WM_CLOSE;
     procedure cboXScheduleEnter(Sender: TObject);
+    procedure pnlXAdminTimeClick(Sender: TObject);
+    procedure cboXSequenceChange(Sender: TObject);
+    procedure cboXSequence1Exit(Sender: TObject);
+    procedure cboXSequenceExit(Sender: TObject);
+    procedure cboXSequenceEnter(Sender: TObject);
+    procedure txtRefillsChange(Sender: TObject);
     //procedure btnNSSClick(Sender: TObject);
   private
+    FCloseCalled : Boolean;
     FScheduleChanged : Boolean;
     {selection}
-    FAllItems:   TStringList;
-    FAllFirst:   Integer;
-    FAllLast:    Integer;
-    FAllList:    Integer;
+    FMedCache:   TObjectList;
+    FCacheIEN:   Integer;
     FQuickList:  Integer;
     FQuickItems: TStringList;
@@ -237,5 +229,4 @@
     FNoZERO: boolean;
     FIsQuickOrder: boolean;
-    FAdminTimeLbl: string;
     FDisabledDefaultButton: TButton;
     FDisabledCancelButton: TButton;
@@ -250,7 +241,18 @@
     FRemoveText : Boolean;
     FSmplPRNChkd: Boolean;
+    {Admin Time}
+    FAdminTimeLbl: string;
+    FMedName: String;
+    FNSSAdminTime: string;
+    FNSSScheduleType: string;
+    FAdminTimeText: string;
+    //FOriginalAdminTime: string;
+    //FOriginalScheduleIndex: integer;
+    FOrderAction: integer;
+    JAWSON: boolean;
     procedure ChangeDelayed;
     function FindQuickOrder(const x: string): Integer;
     function isUniqueQuickOrder(iText: string): Boolean;
+    function GetCacheChunkIndex(idx: integer): integer;
     procedure LoadMedCache(First, Last: Integer);
     procedure ScrollToVisible(AListView: TListView);
@@ -284,5 +286,4 @@
     procedure UpdateRelated(DelayUpdate: Boolean = TRUE);
     procedure UpdateRefills(const CurDispDrug: string; CurSupply: Integer);
-    procedure UpdateSC(const CurDispDrug: string);
     procedure UpdateStartExpires(const CurSchedule: string);
     procedure UpdateDefaultSupply(const CurUnits, CurSchedule, CurDuration, CurDispDrug: string;
@@ -313,11 +314,19 @@
     function IsSupplyAndOutPatient : boolean;
     function GetSchedListIndex(SchedCombo: TORComboBox; pSchedule: String):integer;
+    procedure DisplayDoseNow(Status: boolean);
+    function lblAdminSchGetText: string;
+    procedure lblAdminSchSetText(str: string);
   protected
+    procedure Loaded; override;
     procedure InitDialog; override;
     procedure Validate(var AnErrMsg: string); override;
+    procedure updateSig; override;
   public
     ARow1: integer;
     procedure SetupDialog(OrderAction: Integer; const ID: string); override;
     procedure CheckDecimal(var AStr: string);
+    property MedName: string read FMedName write FMedName;
+    property NSSAdminTime: string read FNSSAdminTime write FNSSAdminTime;
+    property NSSScheduleType: string read FNSSScheduleType write FNSSScheduleType;
   end;
 
@@ -331,22 +340,24 @@
 
 uses rCore, uCore, ORFn, rODMeds, rODBase, rOrders, fRptBox, fODMedOIFA,
-  uAccessibleStringGrid, uOrders, fOtherSchedule, StrUtils, fFrame;
+  uOrders, fOtherSchedule, StrUtils, fFrame, VA508AccessibilityRouter;
 
 const
   {grid columns for complex dosing}
-  COL_SELECT   =  0;
-  COL_DOSAGE   =  1;
-  COL_ROUTE    =  2;
-  COL_SCHEDULE =  3;
-  COL_DURATION =  4;
-  COL_SEQUENCE =  5;
-  COL_CHKXPRN  =  6;
-  VAL_DOSAGE   = 10;
-  VAL_ROUTE    = 20;
-  VAL_SCHEDULE = 30;
-  VAL_DURATION = 40;
-  VAL_SEQUENCE = 50;
-  VAL_CHKXPRN  = 60;
-  TAB          = #9;
+  COL_SELECT    =  0;
+  COL_DOSAGE    =  1;
+  COL_ROUTE     =  2;
+  COL_SCHEDULE  =  3;
+  COL_DURATION  =  4;
+  COL_ADMINTIME =  5;
+  COL_SEQUENCE  =  6;
+  COL_CHKXPRN   =  7;
+  VAL_DOSAGE    = 10;
+  VAL_ROUTE     = 20;
+  VAL_SCHEDULE  = 30;
+  VAL_DURATION  = 40;
+  VAL_ADMINTIME = 50;
+  VAL_SEQUENCE  = 60;
+  VAL_CHKXPRN   = 70;
+  TAB           = #9;
   {field identifiers}
   FLD_LOCALDOSE =  1;
@@ -395,4 +406,6 @@
   TIMER_FROM_DAYS = 1;
   TIMER_FROM_QTY  = 2;
+
+  MED_CACHE_CHUNK_SIZE = 100;
   {text constants}
   TX_ADMIN      = 'Requested Start: ';
@@ -440,4 +453,5 @@
   AutoSizeDisabled := True;
   inherited;
+  FAdminTimeText := '';
   btnXDuration.Align := alClient;
   AllowQuickOrder := True;
@@ -475,5 +489,5 @@
   //if (Self.EvtID > 0) then LoadSchedules(cboSchedule.Items)
   //else LoadSchedules(cboSchedule.Items, FInptDlg);
-  LoadSchedules(cboSchedule.Items, FInptDlg);  
+  LoadSchedules(cboSchedule.Items, FInptDlg);
   StatusText('');
   if FInptDlg then SetControlsInpatient else SetControlsOutpatient;
@@ -482,4 +496,7 @@
   FOrigiMsgDisp := FSuppressMsg;
   InitDialog;
+  isIMO := IfisIMODialog;
+  if (isIMO) or ((FInptDlg) and (encounter.Location <> patient.Location)) then
+      FAdminTimeText := 'Not defined for Clinic Locations';
   if FInptDlg then
   begin
@@ -489,5 +506,5 @@
   end;
   with grdDoses do
-  begin
+  begin                                          
     ColWidths[0] := 8;  // select
     ColWidths[1] := 160; // dosage
@@ -495,17 +512,24 @@
     ColWidths[3] := 102;  // schedule
     ColWidths[4] := 70;  // duration
-    ColWidths[5] := 58;  // and/then
+    if (FInptDlg) and (FAdminTimeText <> 'Not defined for Clinic Locations') then
+      begin
+        ColWidths[5] := 102;  // administration times
+        ColWidths[6] := 58;  // and/then
+      end
+    else
+        ColWidths[5] := 0;
+        ColWidths[6] := 58;
     Cells[1, 0]  := 'Dosage';
     Cells[2, 0]  := 'Route';
     Cells[3, 0]  := 'Schedule';
     Cells[4, 0]  := 'Duration (optional)';
-    Cells[5, 0]  := 'then/and';
-  end;
-  TAccessibleStringGrid.WrapControl(grdDoses);
+    Cells[5, 0]  := 'Admin. Times';
+    Cells[6, 0]  := 'then/and';
+  end;
 
   // medication selection
   FRowHeight := MainFontHeight + 1;
 
-  IsIMO := IfIsIMODialog; //IMO
+  //IsIMO := IfIsIMODialog; //IMO
   if (Self.EvtID > 0) then IsIMO := False; // event order can not be IMO order.
   if FInptDlg then x := 'UD RX'
@@ -517,9 +541,8 @@
     x := 'IVM RX';
   end;
-  ListForOrderable(FAllList, ListCount, x);
+  if self.EvtID > 0  then FAdminTimeText := 'To Be Determined';
+  ListForOrderable(FCacheIEN, ListCount, x);
   lstAll.Items.Count := ListCount;
-  FAllItems := TStringList.Create;
-  FAllFirst := -1;
-  FAllLast  := -1;
+  FMedCache := TObjectList.Create;
   FQuickItems := TStringList.Create;
   ListForQuickOrders(FQuickList, ListCount, x);
@@ -546,4 +569,12 @@
   FShowPnlXScheduleOk := True;
   FRemoveText := True;
+  JAWSON := True;
+  if ScreenReaderActive = false then
+    begin
+      lblAdminTime.TabStop := false;
+      lblAdminSch.TabStop := false;
+      memOrder.TabStop := false;
+      JAWSON := false;
+    end;
 end;
 
@@ -552,10 +583,9 @@
   {selection}
   FQuickItems.Free;
-  FAllItems.Free;
+  FMedCache.Free;
   {edit}
   FGuideline.Free;
   FAllDoses.Free;
   FAllDrugs.Free;
-  TAccessibleStringGrid.UnwrapControl(grdDoses);
   frmFrame.pnlVisit.Enabled := true;
   inherited;
@@ -584,15 +614,22 @@
 procedure TfrmODMeds.SetupDialog(OrderAction: Integer; const ID: string);
 var
-  AnInstr, OrderID, nsSch, Text: string;
+  AnInstr, OrderID, nsSch, Text, tempOrder, tempSchString, tempSchType, AdminTime: string;
   ix: integer;
-begin
-  inherited;
+  LocChange: boolean;
+  AResponse: TResponse;
+
+begin
+  inherited;
+  FOrderAction := OrderAction;
+  if self.EvtID > 0 then DisplayDoseNow(false);
   if XfInToOutNow then DisplayGroup := DisplayGroupByName('O RX');
-  if CharAt(ID,1)='X' then
+  if (CharAt(ID,1)='X') or (CharAt(ID,1)='C') then
   begin
     OrderID := Copy(Piece(ID, ';', 1), 2, Length(ID));
     CheckExistingPI(OrderID, FPtInstruct);
   end;
-  if OrderAction = ORDER_QUICK then
+  //AGP 27.72 Order Action behave similar to QO this is why Edit and Copy are setting FIsQuickOrder to true
+  //this is not the best approach but this should fix the problem with order edit losing the quantity value.
+  if (OrderAction = ORDER_QUICK) or (OrderAction = ORDER_EDIT) or (OrderAction = ORDER_COPY) then
   begin
     FIsQuickOrder := True;
@@ -610,4 +647,13 @@
     Changing := True;
     txtMed.Tag  := StrToIntDef(Responses.IValueFor('ORDERABLE', 1), 0);
+    if (OrderAction = ORDER_QUICK) and (uOrders.PassDrugTstCall = False) and
+     (uOrders.OutptDisp = OutptDisp) and (PassDrugTest(txtMed.Tag, 'Q', false) = False) then Exit;
+    if (OrderAction = ORDER_QUICK) and (uOrders.PassDrugTstCall = False) and
+     ((uOrders.ClinDisp = ClinDisp) or (uOrders.InptDisp = InptDisp)) and (PassDrugTest(txtMed.Tag, 'Q', true) = False) then Exit;
+  (*  if (OrderAction = ORDER_QUICK) then
+      begin
+        tempAltIEN := GetQOAltOI;
+        if tempAltIEN > 0 then txtMed.Tag := tempAltIEN;
+      end; *)
     SetOnMedSelect;                               // set up for this medication
     SetOnQuickOrder;                              // insert quick order responses
@@ -638,7 +684,67 @@
        end;
     end;  //nss
+    //if (FInptDlg) and (self.tabDose.TabIndex = TI_DOSE) and (OrderAction in [ORDER_COPY, ORDER_EDIT])  then
+    if (FInptDlg) and (OrderAction in [ORDER_COPY, ORDER_EDIT])  then
+      begin
+        TempOrder := Piece(id,';',1);
+        TempOrder := Copy(tempOrder, 2, Length(tempOrder));
+        LocChange := DifferentOrderLocations(tempOrder, Patient.Location);
+          if LocChange = false then
+            begin
+              AResponse := Responses.FindResponseByName('ADMIN', 1);
+              if AResponse <> nil then AdminTime := AResponse.EValue;
+              if self.cboSchedule.ItemIndex > -1 then
+                begin
+                  tempSchString := self.cboSchedule.Items.Strings[cboSchedule.itemindex];
+                  SetPiece(tempSchString,U,4,AdminTime);
+                  self.cboSchedule.Items.strings[cboSchedule.ItemIndex] := tempSchString;
+                end;
+              if self.tabDose.TabIndex = TI_COMPLEX then
+                begin
+                  if self.cboXSchedule.ItemIndex > -1 then
+                    begin
+                      tempSchString := self.cboXSchedule.Items.Strings[cboXSchedule.itemindex];
+                      SetPiece(tempSchString,U,4,AdminTime);
+                      self.cboXSchedule.Items.strings[cboXSchedule.ItemIndex] := tempSchString;
+                    end;
+                end;
+              AResponse := Responses.FindResponseByName('SCHTYPE', 1);
+              if AResponse <> nil then tempSchType := AResponse.EValue;
+              if self.cboSchedule.ItemIndex > -1 then
+                begin
+                  if (Piece(self.cboSchedule.Items.Strings[self.cboSchedule.itemIndex], U, 3) = 'C') and (tempSchType = 'P') then
+                     self.chkPRN.Checked := True
+                  else
+                     begin
+                       tempSchString := self.cboSchedule.Items.Strings[cboSchedule.itemindex];
+                       SetPiece(tempSchString,U,3,tempSchType);
+                       self.cboSchedule.Items.strings[cboSchedule.ItemIndex] := tempSchString;
+                     end;
+                  end;
+               if self.tabDose.TabIndex = TI_COMPLEX then
+                begin
+                  if self.cboXSchedule.ItemIndex > -1 then
+                    begin
+                      if  (Piece(self.cboXSchedule.Items.Strings[self.cboXSchedule.itemIndex], U, 3) = 'C') and (tempSchType = 'P') then
+                          self.chkXPRN.Checked := True
+                      else
+                        begin
+                          tempSchString := self.cboXSchedule.Items.Strings[cboXSchedule.itemindex];
+                          SetPiece(tempSchString,U,3,tempSchType);
+                          self.cboXSchedule.Items.strings[cboXSchedule.ItemIndex] := tempSchString;
+                        end;
+                    end;
+                end;
+            end;
+        if (FAdminTimeText <> 'Not defined for Clinic Locations') and (self.tabDose.TabIndex = TI_COMPLEX) then
+            lblAdminSchSetText('');
+        if (FAdminTimeText <> '') and (self.tabDose.TabIndex = TI_DOSE) then lblAdminSchSetText('Admin. Time: ' + FAdminTimeText);
+      end;
     if ((OrderAction <> Order_COPY) and (OrderAction <> Order_EDIT)) or
-    (XfInToOutNow = true) then UpdateRelated(FALSE); //AGP Change
+    (XfInToOutNow = true) or (FIsQuickOrder) then UpdateRelated(FALSE); //AGP Change
     Changing := False;
+    if ((OrderAction = Order_Copy) or (OrderAction = Order_Edit)) and
+        (self.cboSchedule.ItemIndex > -1) then
+          UpdateStartExpires(Piece(self.cboSchedule.items.strings[self.cboSchedule.itemindex], U, 1));
   end;
   { prevent the SIG from being part of the comments on pre-CPRS prescriptions }
@@ -663,5 +769,6 @@
 procedure TfrmODMeds.Validate(var AnErrMsg: string);
 var
-  i,ie,code: Integer;
+  i,ie,code, curSupply, tempRefills: Integer;
+  curDispDrug, tmpError, temp, x: string;
 
   procedure SetError(const x: string);
@@ -736,4 +843,5 @@
   if txtMed.Tag = 0 then SetError(TX_NO_MED);
   if Responses.InstanceCount('INSTR') < 1 then SetError(TX_NO_DOSE);
+  if Pos(U, self.memComment.Text) > 0 then SetError('Comments cannot contain a "^".');
   i := Responses.NextInstance('INSTR', 0);
   while i > 0 do
@@ -757,14 +865,28 @@
     i := Responses.NextInstance('INSTR', i);
   end;
+  if self.tabDose.TabIndex = TI_DOSE then
+     begin
+         if (LeftStr(cboDosage.Text,1)='.') then
+       begin
+         SetError('Dosage must have a leading numeric value');
+         Exit;
+       end;
+     end;
   //AGP Change 26.45 Fix for then/and conjucntion PSI-04-069
-  if self.tabDose.TabIndex = 1 then
-    begin
-       for i := 2 to self.grdDoses.RowCount do
+  if self.tabDose.TabIndex = TI_COMPLEX then
+    begin
+       for i := 1 to self.grdDoses.RowCount do
          begin
-           if ((ValFor(COL_DOSAGE, i-1) <> '') and (ValFor(COL_DOSAGE, i) <> '')) and (ValFor(COL_SEQUENCE,i-1) = '') then
+           temp := ValFor(COL_DOSAGE, i);
+           if (LeftStr(temp,1) = '.') then
              begin
-              SetError(TX_NO_SEQ);
-              Exit;
+                SetError('All dosage must have a leading numeric value');
+                Exit;
              end;
+           if (i > 1) and ((ValFor(COL_DOSAGE, i-1) <> '') and (ValFor(COL_DOSAGE, i) <> '')) and (ValFor(COL_SEQUENCE,i-1) = '') then
+              begin
+                SetError(TX_NO_SEQ);
+                Exit;
+              end;
          end;
     end;
@@ -772,8 +894,35 @@
   begin
     if Responses.IValueFor('PICKUP', 1) = '' then SetError(TX_NO_PICK);
-    if StrToIntDef(Responses.IValueFor('REFILLS', 1), 99) > spnRefills.Max
+    temp := Responses.IValueFor('REFILLS', 1);
+    for i := 1 to Length(temp) do if not (temp[i] in ['0'..'9']) then
+      begin
+        SetError('Refills can only be a number');
+        Exit;
+      end;
+    tempRefills := StrToIntDef(temp, 0);
+    if (spnRefills.Max > 0) and (tempRefills > 0) then
+      begin
+        i := Responses.NextInstance('DOSE', 0);
+        while i > 0 do
+        begin
+          x := ValueOfResponse(FLD_DRUG_ID,   i);
+          CurDispDrug := CurDispDrug + x + U;
+          i := Responses.NextInstance('DOSE', i);
+        end;
+        CurSupply   := StrToIntDef(ValueOfResponse(FLD_SUPPLY)   ,0);
+        UpdateRefills(CurDispDrug, CurSupply);
+      end;
+    if tempRefills > spnRefills.Max
       then SetError(TX_RNG_REFILL + IntToStr(spnRefills.Max));
     with txtQuantity do
-      if not ValidQuantity(Responses.IValueFor('QTY', 1)) then SetError(TX_QTY_NV);
+      begin
+        if not ValidQuantity(Responses.IValueFor('QTY', 1)) then
+          SetError(TX_QTY_NV);
+      (*  else
+          begin
+            Quantity := ValidateQuantityErrorMsg(StrtoIntDef(Responses.IValueFor('QTY', 1), 0));
+            if Quantity <> '' then SetError(Quantity);
+          end; *)
+      end;
     with txtSupply do
     begin
@@ -787,5 +936,10 @@
       if (StrToIntDef(Responses.IValueFor('SUPPLY', 1), 0) > 90) then SetError(TX_SUPPLY_LIM);
       if (StrToIntDef(Responses.IValueFor('SUPPLY', 1), 0) < 1)  then SetError(TX_SUPPLY_LIM1);
-    end;
+      //Supply := ValidateDaySupplyandQuantityErrorMsg(strtoInt(Responses.IValueFor('SUPPLY',1)));
+      //if Supply <> '' then  SetError(Supply);
+    end;
+    tmpError :=  ValidateDaySupplyandQuantityErrorMsg(strtoInt(Responses.IValueFor('SUPPLY',1)),StrtoIntDef(Responses.IValueFor('QTY', 1), 0));
+    if tmpError <> '' then SetError(tmpError)
+    else ClearMaxData;
   end;
 end;
@@ -815,12 +969,12 @@
   lblPriority.Visible := True;
   cboPriority.Visible := True;
-  chkSC.Visible := False;
   chkDoseNow.Visible := True;
   lblAdminTime.Visible := True;
+  lblAdminSch.Visible := True;
+  lblAdminSch.Hint := AdminTimeHelpText;
+  if cboXSequence.Items.IndexOf('except') > -1 then cboXSequence.Items.Delete(cboXSequence.Items.IndexOf('except'));
 end;
 
 procedure TfrmODMeds.SetControlsOutpatient;
-var
-  ExceptItem: TMenuItem;
 begin
   FillerID := 'PSO';
@@ -833,4 +987,5 @@
   lblQuantity.Visible := True;
   txtQuantity.Visible := True;
+  //if IsClozapineOrder = True then txtQuantity.Enabled := false;
   spnQuantity.Visible := True;
   lblQtyMsg.Visible := True;
@@ -841,12 +996,9 @@
   lblPriority.Visible := True;
   cboPriority.Visible := True;
-  chkSC.Visible := True;
   chkDoseNow.Visible := False;
   lblAdminTime.Visible := False;
-  ExceptItem := TMenuItem.Create(Self);
-  ExceptItem.Caption := 'except';
-  ExceptItem.Tag := 3;
-  ExceptItem.OnClick := popXSequenceClick;
-  popXSequence.Items.Add(ExceptItem);
+  lblAdminSch.Visible := False;
+  if cboXSequence.Items.IndexOf('except') = -1 then cboXSequence.Items.Add('except');
+  
 end;
 
@@ -906,5 +1058,13 @@
   x: string;
 begin
-  if Key in [VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN] then             // navigation
+  if txtMed.ReadOnly then    // v27.50 - RV - CQ #15365
+  begin
+    if not (Key in [VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN, VK_HOME, VK_END]) then           // navigation
+    begin
+      Key := 0;
+      Exit;
+    end;
+  end
+  else if (Key in [VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN]) then             // navigation
   begin
     FActiveMedList.Perform(WM_KEYDOWN, Key, 0);
@@ -931,6 +1091,8 @@
   Shift: TShiftState);
 begin
-  if not (Key in [VK_PRIOR, VK_NEXT, VK_UP, VK_DOWN]) then StartKeyTimer;
-end;
+  if txtMed.ReadOnly then exit;    // v27.50 - RV - CQ #15365
+  if not (Key in [VK_PRIOR, VK_NEXT, VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN, VK_HOME, VK_END]) then StartKeyTimer;
+end;
+
 
 procedure TfrmODMeds.txtMedChange(Sender: TObject);
@@ -968,5 +1130,5 @@
   UserText := Copy(txtMed.Text, 1, txtMed.SelStart);
   QuickIndex := FindQuickOrder(UserText);            // look in quick list first
-  AllIndex := IndexOfOrderable(FAllList, UserText);  // but always synch the full list
+  AllIndex := IndexOfOrderable(FCacheIEN, UserText);  // but always synch the full list
   if UserText <> Copy(txtMed.Text, 1, txtMed.SelStart) then Exit;  // if typing during lookup
   if AllIndex > -1 then
@@ -1044,4 +1206,5 @@
 begin
   StopKeyTimer;
+  if txtMed.ReadOnly then exit;        // v27.50 - RV - CQ #15365
   if not ((ActiveControl = lstAll) or (ActiveControl = lstQuick)) then ChangeDelayed;
 end;
@@ -1112,30 +1275,36 @@
 { lstAll Methods (lstAll is TListView) }
 
+procedure TfrmODMeds.Loaded;
+begin
+  inherited;
+  if ScreenReaderSystemActive then
+    tabDose.TabStop := TRUE;
+end;
+
+// Cache is a list of 100 string lists, starting at idx 0
 procedure TfrmODMeds.LoadMedCache(First, Last: Integer);
-const
-  MAX_CACHE_ITEMS = 1000;
-begin
-  // if range is within cache range we don't need to update anything
-  if (First >= FAllFirst) and (Last <= FAllLast) then Exit;
-  // if range is outside of cache or a superset of cache, start over
-  if (Last < Pred(FAllFirst)) or (First > Succ(FAllLast)) or
-     ((First < FAllFirst) and (Last > FAllLast)) or
-     (FAllItems.Count > MAX_CACHE_ITEMS) then
-  begin
-    FAllItems.Clear;
-    FAllFirst := -1;
-    FAllLast  := -1;
-  end;
-  // if getting items immediately before cache range
-  if (First < FAllFirst) and (Last  >= FAllFirst) then Last  := Pred(FAllFirst);
-  // if getting items immediately after cache range
-  if (Last  > FAllLast)  and (First <= FAllLast)  then First := Succ(FAllLast);
-  // retrieve the items and append (First>FAllLast) or prepend them to FAllItems
-  SubsetOfOrderable(FAllItems, First>FAllLast, FAllList, First, Last);
-  // reset FAllFirst & FAllLast indexes to reflect current FAllItems
-  if FAllFirst < 0     then FAllFirst := First;
-  if FAllLast  < 0     then FAllLast  := Last;
-  if First < FAllFirst then FAllFirst := First;
-  if Last > FAllLast   then FAllLast := Last;
+var
+  firstChunk, lastchunk, i: integer;
+  list: TStringList;
+  firstMed, LastMed: integer;
+
+begin
+  firstChunk := GetCacheChunkIndex(First);
+  lastChunk := GetCacheChunkIndex(Last);
+  for i := firstChunk to lastChunk do
+  begin
+    if (FMedCache.Count <= i) or (not assigned(FMedCache[i])) then
+    begin
+      while FMedCache.Count <= i do
+        FMedCache.add(nil);
+      list := TStringList.Create;
+      FMedCache[i] := list;
+      firstMed := i * MED_CACHE_CHUNK_SIZE;
+      LastMed := firstMed + MED_CACHE_CHUNK_SIZE - 1;
+      if LastMed >= lstAll.Items.Count then
+        LastMed := lstAll.Items.Count - 1;
+      SubsetOfOrderable(list, false, FCacheIEN, firstMed, lastMed);
+    end;
+  end;
 end;
 
@@ -1143,8 +1312,11 @@
 var
   x: string;
-begin
-  if (FAllFirst = -1) or (Item.Index < FAllFirst) or (Item.Index > FAllLast)
-    then LoadMedCache(Item.Index, Item.Index);
-  x := FAllItems[Item.Index - FAllFirst];
+  chunk: integer;
+  list: TStringList;
+begin
+  LoadMedCache(Item.Index, Item.Index);
+  chunk := GetCacheChunkIndex(Item.Index);
+  list := TStringList(FMedCache[chunk]);
+  x := list[Item.Index mod MED_CACHE_CHUNK_SIZE];
   Item.Caption := Piece(x, U, 2);
   Item.Data := Pointer(StrToIntDef(Piece(x, U, 1), 0));
@@ -1185,12 +1357,12 @@
 var
   MedIEN: Integer;
-  MedName: string;
+  //MedName: string;
   QOQuantityStr: string;
-  ErrMsg: string;
+  ErrMsg, Temp: string;
 begin
   inherited;
   QOQuantityStr := '';
   btnSelect.SetFocus;                             // let the exit events finish
-
+  self.MedName := '';
   if pnlMeds.Visible then                         // display the medication fields
   begin
@@ -1204,4 +1376,6 @@
       Responses.QuickOrder := Integer(lstQuick.Selected.Data);
       txtMed.Tag  := StrToIntDef(Responses.IValueFor('ORDERABLE', 1), 0);
+      if (not FInptDLG) and (PassDrugTest(TXTmED.Tag, 'N', false) = false) then exit;
+      if (FInptDLG) and (PassDrugTest(TXTmED.Tag, 'N', true) = false) then exit;
       IsActivateOI(ErrMsg, txtMed.Tag);
       if Length(ErrMsg)>0 then
@@ -1209,5 +1383,5 @@
         //btnSelect.Visible := False;
         btnSelect.Enabled := False;
-        ShowMessage(ErrMsg);
+        ShowMsg(ErrMsg);
         Exit;
       end;
@@ -1228,4 +1402,18 @@
         Exit;
       end;
+   (*   temp := self.MedName;
+      tempIEN := txtMed.Tag;
+      QOIEN := GetQOOrderableItem(InttoStr(Responses.QuickOrder));
+      if QOIEN > 0 then
+        begin
+          CheckFormularyOI(tempIEN, temp, FInptDlg);
+          if tempIEN <> txtMed.Tag then
+            begin
+              txtMed.Tag := tempIEN;
+              txtMed.Text := temp;
+            end;
+        end; *)
+      FAltChecked := True;
+      ;
       SetOnMedSelect;   // set up for this medication
       SetOnQuickOrder;  // insert quick order responses
@@ -1233,4 +1421,5 @@
          QOQuantityStr := txtQuantity.Text;
       ShowMedFields;
+      if self.tabDose.TabIndex = TI_COMPLEX then self.lblAdminSch.Visible := false;
       if (txtQuantity.Text = '0') and (Length(QOQuantityStr)>0) then
         txtQuantity.Text := QOQuantityStr;
@@ -1239,5 +1428,7 @@
     begin
       MedIEN := Integer(lstAll.Selected.Data);
-      MedName := lstAll.Selected.Caption;
+      self.MedName := lstAll.Selected.Caption;
+      if (not FInptDLG) and (PassDrugTest(MedIEN, 'N', false) = false) then exit;
+      if (FInptDLG) and (PassDrugTest(MedIEN, 'N', true) = false) then exit;
       txtMed.Tag := MedIEN;
       ErrMsg := '';
@@ -1247,5 +1438,5 @@
         //btnSelect.Visible := False;
         btnSelect.Enabled := False;
-        ShowMessage(ErrMsg);
+        ShowMsg(ErrMsg);
         Exit;
       end;
@@ -1259,7 +1450,8 @@
         Exit;
       end;
-      if Pos(' NF', MedName) > 0 then
-      begin
-        CheckFormularyOI(MedIEN, MedName, FInptDlg);
+      if Pos(' NF', self.MedName) > 0 then
+      begin
+        temp := self.MedName;
+        CheckFormularyOI(MedIEN, temp, FInptDlg);
         FAltChecked := True;
       end;
@@ -1267,5 +1459,7 @@
       begin
         txtMed.Tag := MedIEN;
-        txtMed.Text := MedName;
+        temp := self.MedName;
+        self.MedName := txtMed.Text;
+        txtMed.Text := Temp;
       end;
       SetOnMedSelect;
@@ -1352,4 +1546,5 @@
   cboSchedule.ItemIndex := -1;
   cboSchedule.Text := '';  // leave items intact
+  if FAdminTimeText <> 'Not defined for Clinic Locations' then lblAdminSchSetText('');
   txtSupply.Text := '';
   txtSupply.Tag := 0;
@@ -1371,7 +1566,8 @@
 var
   i,j: Integer;
-  x: string;
+  temp,x: string;
   QOPiUnChk: boolean;
   PKIEnviron: boolean;
+  AResponse: TResponse;
 begin
   // clear controls?
@@ -1380,6 +1576,5 @@
   txtQuantity.Tag := 0;
   spnQuantity.Tag := 0;
-  chkSC.Tag := 0;
-  QOPiUnChk := False;
+   QOPiUnChk := False;
   PKIEnviron := False;
   if GetPKISite then PKIEnviron := True;
@@ -1390,4 +1585,14 @@
     // set up lists & initial values based on orderable item
     SetControl(txtMed,       'Medication');
+    if (self.MedName <> '') then
+       begin
+         if (txtMed.Text <> self.MedName) then
+           begin
+             temp := self.MedName;
+             self.MedName := txtMed.Text;
+             txtMed.Text := temp;
+           end
+         else MedName := '';
+       end;
     SetControl(cboDosage,    'Dosage');
     SetControl(cboRoute,     'Route');
@@ -1395,9 +1600,21 @@
     cboRouteChange(Self);
     x := DefaultText('Schedule');
-    if x <> '' then
+    //AGP Change 27.72 trying to centralized the schedule setting code
+    AResponse := Responses.FindResponseByName('SCHEDULE',1);
+    if (AResponse <> nil) and (AResponse.EValue <> '') then  x := AResponse.EValue;
+    SetSchedule(x);
+   (* if x <> '' then
     begin
       cboSchedule.SelectByID(x);
+      if cboSchedule.ItemIndex > -1 then
+        AdminTime := Piece(cboSchedule.Items.Strings[cboSchedule.itemindex],U,4);
+      if (cboSchedule.ItemIndex < 0) and (RightStr(x,3) = 'PRN')  then
+        begin
+          self.chkPRN.Checked := true;
+          x := Copy(x,1,(Length(x)-3));
+          if RightStr(X,1) = ' ' then x := Copy(x,1,(Length(x)-1))
+        end;
       cboSchedule.Text := x;
-    end;
+    end; *)
     if Length(ValueOf(FLD_QTYDISP))>10 then
     begin
@@ -1431,6 +1648,16 @@
       lblPriority.Top := memcomment.Top + memComment.Height + 1;
       cboPriority.Top := lblPriority.Top + lblPriority.Height;
-      lblAdminTime.Left := chkDoseNow.Left;
-      lblAdminTime.Top := chkDoseNow.Top + chkDoseNow.Height - 1;
+      lblAdminSch.Left := chkDoseNow.Left;
+      lblAdminSch.Top := chkDoseNow.Top + chkDoseNow.Height - 1;
+      lblAdminSch.Height := (MainFontHeight * 3) + 3;
+      lblAdminSch.Width := cboPriority.Left - lblAdminSch.Left - 5;
+      lblAdminTime.Left := lblAdminSch.Left;
+      lblAdminTime.top := lblAdminSch.Top + lblAdminSch.Height -1;
+      if self.tabDose.TabIndex = TI_Dose then lblAdminSchSetText('')
+      else
+        begin
+          if FAdminTimeText = 'Not defined for Clinic Locations' then lblAdminSchSetText('Admin. Time: ' + FAdminTimeText)
+          else self.lblAdminSch.Visible := False;
+        end;
     end else
     begin
@@ -1448,5 +1675,5 @@
       end;
       //if Length(FPtInstruct) = 0 then
-      FPtInstruct := TextOf('PtInstr');
+      if FPtInstruct = '' then FPtInstruct := TextOf('PtInstr');
       for i := 1 to Length(FPtInstruct) do if Ord(FPtInstruct[i]) < 32 then FPtInstruct[i] := ' ';
       FPtInstruct := TrimRight(FPtInstruct);
@@ -1512,9 +1739,10 @@
         if FIsQuickOrder then TempSch := cboSchedule.Text;
         SetSchedule(IValueFor('SCHEDULE', i));
-        if (cboSchedule.Text = '') and FIsQuickOrder then
+        if (cboSchedule.Text = '') and (FIsQuickOrder) and (NSSchedule = False) then
         begin
           cboSchedule.SelectByID(TempSch);
           cboSchedule.Text := TempSch;
         end;
+        if (cboSchedule.Text = '') and (FIsQuickOrder) and (NSSchedule = True) then cboSchedule.ItemIndex := -1;
         x := cboSchedule.Text;
         if chkPRN.Checked then x := x + ' PRN';
